//////////////////////////////////////////////////////////////////////////////////////////
////                                                                                  ////
////                                 Global Variables                                 ////
////                                                                                  ////
//////////////////////////////////////////////////////////////////////////////////////////
extern int MagicNumber=10001;
extern int TakeProfit=10;
extern int StopLoss=10;
extern int LotsMultiplier=2;
extern double minLotSize=0.01;

int Slippage=3;
double MyPoint=Point;

///////////////////////////////////////////////////////////////////////////////////////////
////                                                                                   ////
////                                   Main Function                                   ////
////                                                                                   ////
///////////////////////////////////////////////////////////////////////////////////////////
int start()
{
  if(Digits==3 || Digits==5)
  MyPoint=Point*10;
  
//On Fresh Account, Random Start
  if(
      (OrdersHistoryTotal()==0)&&
      (OrdersTotal()==0)
    )
    {
      if(MathRand()%2==0)
      openBuy();
      else
      openSell();
    }

// Following Orders
  if(
      (OrdersHistoryTotal()>0)&&
      (OrdersTotal()==0)
    )
    {
      if(
          (OrderSelect(OrdersHistoryTotal()-1, SELECT_BY_POS, MODE_HISTORY))&&
          (OrderProfit()>0)
        )
      {
        if(
            (OrderSelect(OrdersHistoryTotal()-1, SELECT_BY_POS, MODE_HISTORY))&&
            (OrderType() == OP_BUY)
          )
        {
          openBuy();
        }
        else
          openSell();
      }
      if(
          (OrderSelect(OrdersHistoryTotal()-1, SELECT_BY_POS, MODE_HISTORY))&&
          (OrderProfit()<0)
        )
      {
        if(
            (OrderSelect(OrdersHistoryTotal()-1, SELECT_BY_POS, MODE_HISTORY))&&
            (OrderType() == OP_BUY)
          )
        {
          openSell();
        }
        else
          openBuy();
      }
    }
  
  return true;
}

//////////////////////////////////////////////////////////////////////////////////////////
////                                                                                  ////
////                                 Custom Functions                                 ////
////                                                                                  ////
//////////////////////////////////////////////////////////////////////////////////////////
double GetLots()
{
  double min_lot = SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MIN);
  double max_lot = SymbolInfoDouble(_Symbol,SYMBOL_VOLUME_MAX);
  double lotSize=min_lot;
  
  if(
      (OrdersHistoryTotal()==0)
      ||
      (
        (OrdersHistoryTotal()>0)&&
        (OrderSelect(OrdersHistoryTotal()-1, SELECT_BY_POS, MODE_HISTORY))&&
        (OrderProfit()>0)
      )
    )
    {
      lotSize= NormalizeDouble((AccountBalance()/baseRisk()), 2);
      if(lotSize < min_lot)
        lotSize = min_lot;
      if(lotSize > max_lot)
        lotSize = max_lot;
    }
  
  if(
      (OrderSelect(OrdersHistoryTotal()-1, SELECT_BY_POS, MODE_HISTORY))&&
      (OrderProfit()<0)
    )
    {
      lotSize= NormalizeDouble((OrderLots()*LotsMultiplier), 2);
      if(lotSize < min_lot)
      {
        lotSize = min_lot;
      }
      if(lotSize > max_lot)
      {
        lotSize = max_lot;
      }
    }  
  return lotSize;
}
//---------------------------------------------------------------------------------------------------------------------
int baseRisk()
{ 
  return AccountBalance()/minLotSize;
}
//---------------------------------------------------------------------------------------------------------------------

int openSell()
{
  if(OrderSend(Symbol(),OP_SELL,GetLots(),Bid,Slippage,0,0,"Martingale",MagicNumber,0,Red))
  {
    double TheTakeProfit=Bid-TakeProfit*MyPoint;
    double TheStopLoss=Bid+StopLoss*MyPoint;
    if(OrderSelect(OrdersTotal()-1,SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(TheStopLoss,Digits),NormalizeDouble(TheTakeProfit,Digits),0,Green))
      return true;
    }
  }
  return true;
}
//---------------------------------------------------------------------------------------------------------------------

int openBuy()
{
  if(OrderSend(Symbol(),OP_BUY,GetLots(),Ask,Slippage,0,0,"Martingale",MagicNumber,0,Blue))
  {
    double TheTakeProfit=Ask+TakeProfit*MyPoint;
    double TheStopLoss=Ask-StopLoss*MyPoint;
    if(OrderSelect(OrdersTotal()-1, SELECT_BY_POS, MODE_TRADES))
    {
      if(OrderModify(OrderTicket(),OrderOpenPrice(),NormalizeDouble(TheStopLoss,Digits),NormalizeDouble(TheTakeProfit,Digits),0,Green))
      return true;
    }
  }
  return true;
}